<?php

/**
 * Minimum interface for persistence usage.
 * 
 * Don't forget these objects are higly likely to be serialized and cached
 * whenever possible. This implies that you might implement the magic methods
 * __sleep() and __wakeup() to ensure that you don't attempt to save system
 * resources or any full object trees.
 */
interface Xoxo_Storable_Interface extends Schema_Exportable_Interface
{
  /**
   * Object is disabled.
   */
  const STATUS_DISABLED = 0;

  /**
   * Object is enabled.
   */
  const STATUS_ENABLED = 1;

  /**
   * Get database integer identifier.
   * 
   * @return int
   */
  public function getIdentifier();

  /**
   * Set database integer identifier.
   * 
   * @param int $oid
   */
  public function setIdentifier($oid);
}
