<?php

/**
 * Default storage for Xoxo_Object instances.
 * 
 * @see Xoxo_Storage
 */
class Xoxo_Storage_Object extends Xoxo_Storage
{
  /**
   * @see Xoxo_Storage::_populate()
   */
  protected function _populate($row, Xoxo_Object $object) {
    parent::_populate($row, $object);
    $object->setOwner((int)$row->uid);
    $object->setStatus((int)$row->status);
// FIXME
//    $object->_setStorage($this);
  }

  /**
   * @see Xoxo_Storage::_preSave()
   */
  protected function _preSave(Xoxo_Storable_Interface $object, &$data) {
    $data['type'] = $object->getType();
  }

  /**
   * Delete objects owned by the given account.
   * 
   * @param int|object $account
   *   Account identifier or object.
   * 
   * @return int
   *   Number of rows deleted.
   */
  public function deleteByOwner($account) {
    $uid = is_object($account) ? $account ->uid : $account;
    return $this->deleteByField(array('uid', $uid));
  }
}
