<?php
// $Id$

/**
 * Custom registry automatically feeded using a variable instead of a custom
 * hook over modules.
 */
class XoxoEntity_Registry extends Oox_Registry
{
  /**
   * Load cache from Drupal cache.
   */
  protected function _loadItemCache() {
    if (!isset($this->_cache)) {
      $this->_cache = array();
      foreach (variable_get('xoxo_entities_items_' . $this->_type, array()) as $itemType => $itemInfo) {
        if ($itemInfo = $this->_checkItem($itemType, $itemInfo, 'xoxo_entity')) {
          $this->_cache[$itemType] = $itemInfo;
        }
      }
      if (!empty($this->_cache)) {
        uasort($this->_cache, '_oox_registry_compare');
      }
    }
  }
}
