<?php
// $Id$

/**
 * @file
 * Entity creation and deletion low level API.
 */

/**
 * Get a new table name for a spawned entity.
 */
function xoxo_entity_api_table_name($entityType) {
  return 'xoxo_entity_' . $entityType;
}

/**
 * Get default table schema for custom entity tables.
 */
function xoxo_entity_api_table_schema() {
  return drupal_get_schema_unprocessed('xoxo', 'xoxo_object');
}

/**
 * Create storage info structure from incomplete structure.
 */
function xoxo_entity_api_storage_info($entityType, $storageInfo = array()) {
  return $storageInfo + array(
    'name' => $entityType,
    'registry_type' => $entityType,
    'administrable' => TRUE,
    'table' => xoxo_entity_api_table_name($entityType),
    'class' => 'Xoxo_Storage',
  );
}

/**
 * Create registry info structure from incomplete storage info structure.
 */
function xoxo_entity_api_registry_info($entityType, $storageInfo = array()) {
  // This will leave a junk of useless information, but it won't hurt.
  return array('class' => 'XoxoEntity_Registry') + $storageInfo + array('name' => $entityType);
}
